unit tlcunit;


interface

uses
  WinTypes, WinProcs, Printers, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TTLC = class(TForm)
    Memo1: TMemo;
    Lectbut: TButton;
    Savebut: TButton;
    CHARGER: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label2: TLabel;
    Button1: TButton;
    PrintDialog1: TPrintDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure LectbutClick(Sender: TObject);
    procedure SavebutClick(Sender: TObject);
    procedure CHARGERClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  TLC: TTLC;
  lu: string;

implementation
uses clipbrd;
{$R *.DFM}
function outport(outbyte: byte): byte;
  begin
    asm
    MOV DX,888
    MOV AL,outbyte
    OUT (DX),AL
    end;
  end;
function inport: byte;
  begin
    asm
    MOV DX,889
    IN AL,(DX)
    MOV @result,AL
    end;

  end;


procedure TTLC.LectbutClick(Sender: TObject);
var i,j,k: byte;
begin
showmessage('Insrer une carte');
tlc.Memo1.text:='';
    outport(248); outport(252); outport(254);
    outport(252); outport(248);
    for i:= 1 to 8 do
 begin
 lu:='';
 for j:= 1 to 8 do
   begin
       for k:= 1 to 4 do
         begin
         outport(249);
         if (inport and 128) = 128 then
         lu:= lu + '0 ' else
         lu:= lu + '1 ';
         outport(251);
       end;
       lu:= lu + ' ';
   end;
 tlc.memo1.Lines.add (lu);

 end;
tlc.memo1.lines.add ('');
 end;

procedure TTLC.SavebutClick(Sender: TObject);
begin

if savedialog1.execute then
  begin
  tlc.memo1.lines.savetofile(tlc.savedialog1.filename);
  end;
end;

procedure TTLC.CHARGERClick(Sender: TObject);
begin
if tlc.opendialog1.execute then
  begin
  tlc.memo1.lines.LoadFromFile(tlc.opendialog1.filename);
  end;
end;

procedure TTLC.Button1Click(Sender: TObject);
var
printext: textfile;
line: integer;
begin
 if printdialog1.execute then
 begin
  assignprn(printext);
  rewrite(printext);
try
  writeln(printext);
  for line:= 0 to memo1.Lines.Count do
  writeln(printext,memo1.lines[line]);
finally
  closefile(printext);
end;
 end;
end;

procedure TTLC.Button2Click(Sender: TObject);
begin
tlc.memo1.selectall;
tlc.memo1.copytoclipboard;
end;

procedure TTLC.Button3Click(Sender: TObject);
var j,k: byte;
begin
lu:='';
begin
 for j:= 1 to 8 do
   begin
       for k:= 1 to 4 do
         begin
         outport(249);
         if (inport and 128) = 128 then
         lu:= lu + '0 ' else
         lu:= lu + '1 ';
         outport(251);
       end;
       lu:= lu + ' ';
   end;
 tlc.memo1.Lines.add (lu);
end;
end;

procedure TTLC.Button4Click(Sender: TObject);
begin
tlc.Memo1.lines.add ('');
end;

end.
